features:
  primary:
    - name: "Dynamic environments support for Review Apps"
      available_in: [core, starter, premium, ultimate]
      documentation_link: 'https://docs.gitlab.com/ee/ci/environments.html#set-dynamic-environment-urls-after-a-job-finishes'
      video: 'https://www.youtube.com/embed/70jDXtOf4Ig'
      reporter: ogolowinski
      stage: release
      categories:
        - 'Review Apps'
      issue_url: 'https://gitlab.com/gitlab-org/gitlab/-/issues/17066'
      description: |
       Review apps currently require a static URL to be used as the CI/CD variable `CI_ENVIRONMENT_SLUG`. In many use cases, though, this environment variable is dynamic instead of static. For example, when using AWS, a user may want to use the environment name based on the stage, which may not be known before the deployment.

       In 12.9, we've introduced a new report artifact, `dotenv`. The artifact can be passed between jobs, providing truly dynamic URL support for Review Apps. This unlocks the ability to use Review Apps in dynamic environments, such as native cloud deployments.
